# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetFloatingIpResult',
    'AwaitableGetFloatingIpResult',
    'get_floating_ip',
    'get_floating_ip_output',
]

@pulumi.output_type
class GetFloatingIpResult:
    """
    A collection of values returned by getFloatingIp.
    """
    def __init__(__self__, api_version=None, floating_ip_uuid=None, id=None, metadata=None, specs=None, statuses=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if floating_ip_uuid and not isinstance(floating_ip_uuid, str):
            raise TypeError("Expected argument 'floating_ip_uuid' to be a str")
        pulumi.set(__self__, "floating_ip_uuid", floating_ip_uuid)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if specs and not isinstance(specs, list):
            raise TypeError("Expected argument 'specs' to be a list")
        pulumi.set(__self__, "specs", specs)
        if statuses and not isinstance(statuses, list):
            raise TypeError("Expected argument 'statuses' to be a list")
        pulumi.set(__self__, "statuses", statuses)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        """
        The version of the API.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter(name="floatingIpUuid")
    def floating_ip_uuid(self) -> str:
        return pulumi.get(self, "floating_ip_uuid")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadata(self) -> Mapping[str, str]:
        """
        - The floating_ip kind metadata.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def specs(self) -> Sequence['outputs.GetFloatingIpSpecResult']:
        """
        Floating IP spec
        """
        return pulumi.get(self, "specs")

    @property
    @pulumi.getter
    def statuses(self) -> Sequence['outputs.GetFloatingIpStatusResult']:
        """
        Floating IP output status
        """
        return pulumi.get(self, "statuses")


class AwaitableGetFloatingIpResult(GetFloatingIpResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFloatingIpResult(
            api_version=self.api_version,
            floating_ip_uuid=self.floating_ip_uuid,
            id=self.id,
            metadata=self.metadata,
            specs=self.specs,
            statuses=self.statuses)


def get_floating_ip(floating_ip_uuid: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFloatingIpResult:
    """
    Provides a datasource to retrieve floating IPs with floating_ip_uuid .


    :param str floating_ip_uuid: Floating IP UUID
    """
    __args__ = dict()
    __args__['floatingIpUuid'] = floating_ip_uuid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getFloatingIp:getFloatingIp', __args__, opts=opts, typ=GetFloatingIpResult).value

    return AwaitableGetFloatingIpResult(
        api_version=pulumi.get(__ret__, 'api_version'),
        floating_ip_uuid=pulumi.get(__ret__, 'floating_ip_uuid'),
        id=pulumi.get(__ret__, 'id'),
        metadata=pulumi.get(__ret__, 'metadata'),
        specs=pulumi.get(__ret__, 'specs'),
        statuses=pulumi.get(__ret__, 'statuses'))


@_utilities.lift_output_func(get_floating_ip)
def get_floating_ip_output(floating_ip_uuid: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFloatingIpResult]:
    """
    Provides a datasource to retrieve floating IPs with floating_ip_uuid .


    :param str floating_ip_uuid: Floating IP UUID
    """
    ...
